#include	<windows.h>
#include	<stdio.h>
#include	<string.h>
#include	"xmil.h"
#include	"x1.h"
#include	"x1_cmt.h"
#include	"x1_scpu.h"
#include	"x1_clndr.h"
#include	"input.h"
#include	"dosio.h"

#if T_TUNE
#include	"x1_irq.h"
#include	"x1_cmt.h"
#endif
/***********************************************************************
	SUB CPU
***********************************************************************/

		SCPU_TABLE	scpu;

//							  e3 e4 e5 e6 e7 e8 e9 ea eb ec ed ee ef
const	BYTE	CMD_TBL[] = {  0, 1, 0, 0, 1, 0, 1, 0, 0, 3, 0, 3, 0};
#if !T_TUNE
const	BYTE	DAT_TBL[] = {  3, 0, 0, 2, 0, 1, 0, 1, 1, 0, 3, 0, 3};
#endif

#if T_TUNE
/* CMT breakable flags          EJ,ST,PL,FF,RE,AF,AR, -, -, -,RC, */
static const BYTE BRK_TLB[] = {  0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1 };
#define cmt_can_break() (BRK_TLB[scpu.Ex[0xa][0]])
#endif

//**********************************************************************

void init_scpu(void) {

	ZeroMemory(&scpu, sizeof(scpu));
	scpu.OBF = 1;
}

#if T_TUNE
//**********************************************************************
// L[{[hM
/* ߂ĺAL[M̃EFCgl */
static int x1_sub_keyin(void)
{
	/* L[f[^AL[󂢂Ă΃L[ɏ */
	if (KEY_INT)
	{
		/* L[f[^ǂݍ */
		keyboard_inkey(xmilcfg.KEY_MODE, scpu.keyque[7] );
		KEY_INT = 0;
		/* CMTL[ , BREAKL[CMT~ */
		switch( scpu.keyque[7][1] )
		{
		case 0xc0:
		case 0xc1:
		case 0xc3:
		case 0xc4:
		case 0xc5:
		case 0xc6:
			/* eL[{LL[̂ݓ */
			if( scpu.keyque[7][0] & 0xc0 != 0xc0 )
				break;
			if(cmt_can_break())
			{
				/* 250msԁAu[NMo */
				scpu.cmt_break_cnt = 250; /* 250ms */
			}
			/* cmt controll */
			scpu.Ex[0xa][0] = scpu.keyque[7][1]-0xc0;
			cmt_ctrl(scpu.Ex[0xa][0],0);
			/* L[𖳌ɂႨ */
			scpu.keyque[7][0] &= 0x40;
			scpu.keyque[7][1] = 0x00;
			break;
		case 0x03: /* BERAK */
			/* FFREW͒~Ȃ */
			if(cmt_can_break())
			{
				scpu.Ex[0xa][0] = CMT_STOP;
				cmt_ctrl(CMT_STOP,0);
			}
			break;
		}

		/* L[̍Ō̃f[^u͖v̎͏㏑ */
		if( (scpu.keyque_cnt>0) && (scpu.keyque[(scpu.keyque_rp+scpu.keyque_cnt-1)%7][0]&0x40) )
			scpu.keyque_cnt--;
		/* L[󂢂ĂΏ */
		if( scpu.keyque_cnt < 7)
		{
			scpu.keyque[(scpu.keyque_rp+scpu.keyque_cnt)%7][0] = scpu.keyque[7][0];
			scpu.keyque[(scpu.keyque_rp+scpu.keyque_cnt)%7][1] = scpu.keyque[7][1];
			scpu.keyque_cnt++;
		}
		/* ͌A25ms̓TubotbN */
/*		scpu.keyin_wait = 25 +1;*/
	}
	/* L[M̃EFCglԂ */
	return scpu.keyin_wait ? --scpu.keyin_wait : 0;
}

//**********************************************************************
// R}hs
/* KoCgMɔ */
void x1_sub_cmd(void)
{
	/* f[^|C^̃vZbg */
	if( scpu.MODE >= 0xe3 && scpu.MODE <= 0xef)
		scpu.datap = SCPUOFST(Ex[scpu.MODE - 0xe0][0]);
	scpu.DAT_CNT = 0;

	/* R}h̎s */
	switch(scpu.MODE)
	{
	case 0xe3: /* gamekey(MODE-B) read */
		if (xmilcfg.KEY_MODE) {
			scpu.Ex[0x03][0] =
			scpu.Ex[0x03][1] =
			scpu.Ex[0x03][2] = 0;
		}
		else {
			keyboard_e3(scpu.Ex[0x03]);
		}
		scpu.DAT_CNT = 3;
		break;
	case 0xe4: /* irq vector */
		break;
	case 0xe6: /* keydata read */
		if( scpu.keyque_cnt )
		{	/* L[L[烊[h */
			scpu.Ex[0x06][0] = scpu.keyque[scpu.keyque_rp][0];
			scpu.Ex[0x06][1] = scpu.keyque[scpu.keyque_rp][1];
			scpu.keyque_rp = (scpu.keyque_rp+1) % 8;
			scpu.keyque_cnt--;
		}
		else
		{	/* L[Ȃ̂ŁAŌ̃L[񂩂uL[́v菜 */
			scpu.Ex[0x06][0] &= 0xbf;
		}
		scpu.DAT_CNT = 2;
		break;
	case 0xe7: /* TV controll */
		scpu.Ex[0x08][0] = scpu.Ex[0x07][0];
		break;
	case 0xe8: /* TV controll read */
		scpu.DAT_CNT = 1;
		break;
	case 0xe9: /* CMT controll */
		if( scpu.Ex[0x9][0] <= CMT_REC )
		{
			scpu.Ex[0xa][0] = scpu.Ex[0x9][0];
			cmt_ctrl(scpu.Ex[0x9][0],0);
		}
		break;
	case 0xea: /* CMT status */
		cmt_ctrl(CMT_STATUS,0); /* to CZ8RL1, return for x1_sub_cmtrx() */
		scpu.DAT_CNT = 1;
		break;
	case 0xeb: /* CMT sencer */
		cmt_ctrl(CMT_SENSOR,0); /* to CZ8RL1, return for x1_sub_cmtrx() */
		scpu.DAT_CNT = 1;
		break;
	case 0xec: /* set calender */
		clndr_setdate(scpu.Ex[0x0c]);
		break;
	case 0xed: /* get calender */
		clndr_getdate(scpu.Ex[0x0d]);
		scpu.DAT_CNT = 3;
		break;
	case 0xee: /* set time */
		clndr_settime(scpu.Ex[0x0e]);
		break;
	case 0xef: /* get time */
		clndr_gettime(scpu.Ex[0x0f]);
		scpu.DAT_CNT = 3;
		break;
	case 0xd0: /* timer0 set */
	case 0xd1: /* timer1 set */
	case 0xd2: /* timer2 set */
	case 0xd3: /* timer3 set */
	case 0xd4: /* timer4 set */
	case 0xd5: /* timer5 set */
	case 0xd6: /* timer6 set */
	case 0xd7: /* timer7 set */
		break;
	case 0xd8: /* timer0 set */
	case 0xd9: /* timer1 set */
	case 0xda: /* timer2 set */
	case 0xdb: /* timer3 set */
	case 0xdc: /* timer4 set */
	case 0xdd: /* timer5 set */
	case 0xde: /* timer6 set */
	case 0xdf: /* timer7 set */
		scpu.DAT_CNT = 6;
		scpu.datap = SCPUOFST(Dx[scpu.MODE - 0xd0][0]);
		break;
	}
	/* R}htI */
	scpu.MODE = 0x00;
}

#endif /* T_TUNE */
//**********************************************************************

// L[{[h荞
short x1_sub_int(void) {								// 990922
#if T_TUNE
	/* CMTu[No͂̃JEg_E */
	if( scpu.cmt_break_cnt )
		scpu.cmt_break_cnt--;
	/* L[f[^̎M */
	if( x1_sub_keyin() )
	{	/* L[f[^M(25msԁH)́AAPSSȊOȂɂoȂ */
		return(1);
	}
	/* APSSśAL[͈ȊOłȂI */
	if( (scpu.Ex[0x0a][0] == CMT_AFF) || (scpu.Ex[0x0a][0] == CMT_AREW) )
		return(1);

	/* R}htȂACbot烉Cgf[^M */
	if( scpu.CMD_CNT )
	{
		if( scpu.IBF)
		{
			*((BYTE *)(&scpu) + scpu.datap) = scpu.IBUF;
			scpu.datap++;
			scpu.IBF = 0;
			if (--scpu.CMD_CNT == 0)
				x1_sub_cmd();
		}
		return(1);
	}
	/* Xe[^XMȂACbotփ[hf[^̑M */
	if( scpu.DAT_CNT)
	{
		if(scpu.OBF)
		{
			scpu.OBUF = *((BYTE *)(&scpu) + scpu.datap);
			scpu.datap++;
			scpu.OBF = 0;
			scpu.DAT_CNT--;
		}
		return(1);
	}
	/* L[́A荞݃xN^A荞ݗvȂA荞ݔI */
	if (scpu.keyque_cnt && scpu.Ex[4][0] && !X1_check_pending_irq(DEVICE_SUB))
	{
		/* L[L[烊[h */
		scpu.MODE = 0xe6;
		x1_sub_cmd();
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	{̃V[PXł́A荞݃xN^o͂ɁAQoCg
	AXL[R[ho͂
	Z80̊荞݃xN^tFb`TCNŁAIO(1900)xN^ǂ݂Ƃ
	̂
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
		/* 荞ݔvI */
		X1_set_irq_vector(DEVICE_SUB,scpu.Ex[4][0]);
		X1_set_irq_line(DEVICE_SUB);
		return 0;
	}
	/* VKR}h̎t */
	if (scpu.IBF)
	{
		scpu.MODE = scpu.IBUF;
		scpu.IBF = 0;
		scpu.CMD_CNT = 0;
		if (scpu.MODE >= 0xd0 && scpu.MODE <= 0xd7) {
			scpu.CMD_CNT = 6;
			scpu.datap = SCPUOFST(Dx[scpu.MODE - 0xd0][0]);
		}
		else if (scpu.MODE >= 0xe3 && scpu.MODE <= 0xef) {
			scpu.CMD_CNT = CMD_TBL[scpu.MODE - 0xe3];
			scpu.datap = SCPUOFST(Ex[scpu.MODE - 0xe0][0]);
		}
		/* OoCgR}h̎s */
		if(scpu.CMD_CNT==0)
			x1_sub_cmd();
	}
	return (1);
#else /* T_TUNE */

#if 1
	if ((!KEY_INT) || (scpu.CMD_CNT) || (scpu.DAT_CNT) ||
		(!Z80_Able_interrupt())) {						// 荞߂Ȃ
		return(1);										// ܂T`
	}
#else
	if ((!KEY_INT) || (scpu.CMD_CNT) || (scpu.DAT_CNT)) {
		return(1);
	}
#endif
	KEY_INT = 0;
	if (!scpu.Ex[4][0]) {				// 荞ݕsv̂Ă
		return(1);
	}
	if (KEY_HIT) {						// L[ꂽꍇ
		keyboard_inkey(xmilcfg.KEY_MODE, scpu.Ex[0x06]);
		if (!scpu.Ex[0x06][1]) {		// ȃL[̂Ă
			return(1);
		}
		scpu.INT_SW = 1;
	}
	else {
		if (!scpu.INT_SW) {				// ĂȂ犄荞܂Ȃ
			return(1);
		}
		scpu.INT_SW = 0;
		keyboard_inkey(xmilcfg.KEY_MODE, scpu.Ex[0x06]);
	}

//	x1_sub_w(0x1900, 0xe6);				// KeyǂݎŃXe[^Xς
										// ܂悤ɂȂ....
	scpu.MODE = 0xe6;
	scpu.CMD_CNT = 0;
	scpu.DAT_CNT = 2;
	scpu.datap = SCPUOFST(Ex[0xe6 - 0xe0][0]);
	scpu.OBF = 0;
	scpu.IBF = 1;

	Z80_Cause_Interrupt2(scpu.Ex[4][0]);
	return(0);
#endif /* T_TUNE */
}

//**********************************************************************

X1_IOW x1_sub_w(WORD port, BYTE value) {
#if T_TUNE
	scpu.IBUF = value;
	scpu.IBF = 1;
#else /* T_TUNE */
	if (scpu.IBF) {
		return;
	}
	if (!scpu.CMD_CNT) {
		scpu.MODE = value;
		scpu.CMD_CNT = 0;
		scpu.DAT_CNT = 0;
		if (value >= 0xd0 && value <= 0xd7) {
			scpu.CMD_CNT = 6;
			scpu.DAT_CNT = 0;
		}
		else if (value >= 0xd8 && value <= 0xdf) {
			scpu.CMD_CNT = 0;
			scpu.DAT_CNT = 6;
		}
		else if (value >= 0xe3 && value <= 0xef) {
			scpu.CMD_CNT = CMD_TBL[value - 0xe3];
			scpu.DAT_CNT = DAT_TBL[value - 0xe3];
		}
		if (value < 0xe0) {
			scpu.datap = SCPUOFST(Dx[value - 0xd0][0]);
		}
		else {
			scpu.datap = SCPUOFST(Ex[value - 0xe0][0]);
		}
		switch(scpu.MODE) {							// 990225 puni
			case 0xe3:
				if (xmilcfg.KEY_MODE) {
					scpu.Ex[0x03][0] = 0;
					scpu.Ex[0x03][1] = 0;
					scpu.Ex[0x03][2] = 0;
				}
				else {
					keyboard_e3(scpu.Ex[0x03]);
				}
				break;

			case 0xe6:
				keyboard_inkey(xmilcfg.KEY_MODE, scpu.Ex[0x06]);
				break;

			case 0xed:
				clndr_getdate(scpu.Ex[0x0d]);
				break;

			case 0xef:
				clndr_gettime(scpu.Ex[0x0f]);
				break;
		}
	}
	else {
		*((BYTE *)(&scpu) + scpu.datap) = value;
		scpu.datap++;
		if (--scpu.CMD_CNT == 0) {
			switch(scpu.MODE) {
				case 0xe9:
					cmt_ctrl(scpu.Ex[0x9][0]);
					break;
				case 0xec:
					clndr_setdate(scpu.Ex[0x0c]);
					break;
				case 0xee:
					clndr_settime(scpu.Ex[0x0e]);
					break;
			}
		}
	}
	scpu.OBF = (BYTE)(scpu.DAT_CNT?0:1);
	scpu.IBF = (BYTE)(scpu.DAT_CNT?1:0);
#endif /* T_TUNE */
}


X1_IOR x1_sub_r(WORD port) {
#if T_TUNE
	scpu.OBF = 1;
	return scpu.OBUF;
#else /* T_TUNE */
	BYTE	ret;
#if 1										// D-SIDE Œʂ悤Ɂc
	if (!scpu.DAT_CNT) {					// |C^͕ςȂH
		scpu.DAT_CNT++;

		switch(scpu.MODE) {						// 990225 puni
			case 0xe3:
				if (xmilcfg.KEY_MODE) {
					scpu.Ex[0x03][0] = 0;
					scpu.Ex[0x03][1] = 0;
					scpu.Ex[0x03][2] = 0;
				}
				else {
					keyboard_e3(scpu.Ex[0x03]);
				}
				break;

			case 0xe6:
				keyboard_inkey(xmilcfg.KEY_MODE, scpu.Ex[0x06]);
				break;

			case 0xed:
				clndr_getdate(scpu.Ex[0x0d]);
				break;

			case 0xef:
				clndr_gettime(scpu.Ex[0x0f]);
				break;
		}
	}

#else
	if (scpu.OBF) {
		return(0);
	}
#endif
	ret = 0;
	switch(scpu.MODE) {
		case 0xd8:
		case 0xd9:
		case 0xda:
		case 0xdb:
		case 0xdc:
		case 0xdd:
		case 0xde:
		case 0xdf:
			ret = scpu.Dx[scpu.MODE - 0xd8][6 - scpu.DAT_CNT];
			break;
		case 0xe3:
			ret = scpu.Ex[0x03][3 - scpu.DAT_CNT];
			break;
		case 0xe6:
#if T_TUNE
//				X1_clear_ieo_line(DEVICE_SUB);
#endif
			ret = scpu.Ex[0x06][2 - scpu.DAT_CNT];
			break;
		case 0xe8:
			ret = scpu.Ex[0x07][0];
			break;
		case 0xea:
			ret = cmt_ctrl_stat();
			break;
		case 0xeb:
			ret = cmt_tape_stat();
			break;
		case 0xed:
			ret = scpu.Ex[0x0d][3 - scpu.DAT_CNT];
			break;
		case 0xef:
			ret = scpu.Ex[0x0f][3 - scpu.DAT_CNT];
			break;
	}
	scpu.DAT_CNT--;
	scpu.OBF = (BYTE)(scpu.DAT_CNT?0:1);
	scpu.IBF = (BYTE)(scpu.DAT_CNT?1:0);
	return(ret);
#endif /* T_TUNE */
}

#if T_TUNE
/* CZ8RL1 -> X1 ]f[^ */
void x1_sub_cmtrx(BYTE data)
{
	BYTE sel;

	/* JZbg̃{^Ae[vGhɂu[Nʒm */
	if(data==0xff)
	{
		/* 250msԁAu[NMo */
		scpu.cmt_break_cnt = 250; /* 250ms */
		return;
	}

	/* b7=0 : CMT̏ԂłACMTR}hsɂM܂ */
	sel = data/128;
	/* b6..0: CMTԖ̓ZT[̒l */
	data &= 0x7f;
	/* Xe[^X̓o^ */
	scpu.Ex[0x0a + sel][0] = data & 0x7f;
}

/* BREAK rbgo */
BYTE x1_sub_getbreak(void)
{
	/* BREAK KEY */
	if( scpu.keyque[7][1] == 0x03)
		return 0x00; /* BREAK KEY */
	/* CMT BREAK */
	if( scpu.cmt_break_cnt > 0)
		return 0x00; /* BREAK KEY */

	/* NO BREAK */
	return 0x01;
}
#endif
