#if T_TUNE
/* all of source was replaced , based "x1_tape.c" in X1EMU 0.5 */

/*
	x1_sub_cpu.cƂ̋ÉACZ8Rl1 : X1̏ɂȂĂ
*/

#include	<windows.h>
#include	<stdio.h>
#include	"x1.h"
#include	"xmil.h"
#include	"x1_cmt.h"
#include	"menu.h"
#include	"dosio.h"
#include	"dsounds.h"

/* */
#define tape_freq (tape.header.frequency)
#define tape_pos  (tape.header.position)
#define tape_end  (tape.header.datasize)
#define tape_protect (tape.header.protect)

/* APSS̃TvOrbgAoCgANZX̂łW̔{ɂ鎖 */
#define FF_REW_RATE 8*3

CMT_TABLE tape;
static char tape_filename[128] = { 0 };

/* JZbgJ^C}[Cxg֘A */
static EVENT motor_event = EVENT_VALUE(NULL,0,NULL,0);
static EV_TIME motor_interval;

static void cmt_head_up(void);

static const X1TAPE_HEADER default_header =
{
	TAPE_INDEX,
	"auto converted",
	{0,0,0,0,0},
	0,
	TAPE_FORMAT_SAMPLING,
	0,
	8000,
	0
};

/**********************************************************************
	Xe[^X̍쐬ƁA^Cgo[ւ̕\
**********************************************************************/
/* update tape state and window title */
char *cmt_get_stat_str(void)
{
	static char work[128];

	unsigned long t;
	int s,m,h;
	static const char *cmt_cmd_str[]=
	{
		"EJT","STP","PLY","FF ",
		"REW","AFF","ARW","   ",
		"   ","   ","REC"
	};

	t=tape_freq ? (tape_pos / tape_freq) : 0;
	s=(int)(t%60l); t/=60l;
	m=(int)(t%60l); t/=60l;
	h=(int)(t%60l);
	sprintf(work," %s(%1d:%02d:%02d)",cmt_cmd_str[tape.cur_cmd],h,m,s);

	return work;
}

/**********************************************************************
	
**********************************************************************/
void init_cmt(void)
{
	if( tape_filename[0] == 0)
	{
	  ZeroMemory(&tape, sizeof(CMT_TABLE));
	  tape.cur_cmd = CMD_EJECT;
	  cmt_set_protect(0);
	}
	else
	{
		cmt_stop();
	}
}

/**********************************************************************
	e[vwb_[̃Z[u
**********************************************************************/
static void cmt_save_header(void)
{
	/* output tape position */
	if( (tape.header.index == TAPE_INDEX) && (tape_freq != 0) )
	{
		FILEH hdr;

		/* write header to file */
		if ((hdr = file_open(tape_filename)) != (FILEH)-1)
		{
			if (file_seek(hdr, 0, FSEEK_SET) == 0)
				file_write(hdr, &tape.header, sizeof(tape.header));
				file_close(hdr);
		}
	}
}

/**********************************************************************
	e[vt@C̓ǂݏ
**********************************************************************/
/* ꎞobt@t@CɍXVĔj */
static int cmt_flush_buffer(void)
{
	FILEH hdr;
	DWORD cur_ptr;
	int ret = 0;

	if(!tape_freq)
		return(-1);

	if (!tape.dirty_buf || (tape.page==-1) )
		return(0);

	if ((hdr = file_open(tape_filename)) == (FILEH)-1) {
		return(-1);
	}

	cur_ptr = (DWORD)tape.page * CMT_PAGE_SIZE + sizeof(X1TAPE_HEADER);
	tape.page = -1;
	tape.dirty_buf = 0;
	if ((file_seek(hdr, cur_ptr, FSEEK_SET) != cur_ptr) ||
		(file_write(hdr, tape.buf, tape.buf_size) != tape.buf_size)) {
		ret = -1;
	}
	if (file_close(hdr)) {
		ret = -1;
	}
	return(ret);
}

/* e[vʒuɑf[^̃|C^𓾂 */
/* Kv΁Aꎞobt@XVAǂݍ݂s */
static BYTE *cmt_data_ptr(DWORD pos)
{
	static BYTE dummy_data=0;
	FILEH hdr;
	DWORD cur_ptr;
	WORD page;

	/* e[vC[WȂ_~[Ԃ */
	if(!tape_freq)
		return(&dummy_data);

	/* ݂̃obt@ɓɑ݂΁AԂ */
	page = (WORD)(pos / CMT_PAGE_SIZE);
	pos %= CMT_PAGE_SIZE;
	if(tape.page == page)
		return &tape.buf[pos];

	/* ݂̃obt@XVĔj */
	/* flush current buffer */
	if( cmt_flush_buffer() < 0)
		return(&dummy_data);

	/* C[Wt@CJ /
	/* read new buffer */
	if ((hdr = file_open(tape_filename)) == (FILEH)-1)
		return(&dummy_data);

	/* obt@̃t@CʒuƁAobt@TCY̌vZ */
	cur_ptr = (DWORD)page * CMT_PAGE_SIZE + sizeof(X1TAPE_HEADER);
	if(cur_ptr+CMT_PAGE_SIZE > tape.filesize)
		tape.buf_size = (WORD)(tape.filesize - cur_ptr);
	else
		tape.buf_size = CMT_PAGE_SIZE;

	/* t@C̃V[Nƃ[h */
	if ((file_seek(hdr, cur_ptr, FSEEK_SET) != cur_ptr) ||
		(file_read(hdr, tape.buf, tape.buf_size) != tape.buf_size))
	{
		file_close(hdr);
		return &dummy_data;
	}

	if (file_close(hdr))
		return &dummy_data;

	tape.page = page;
	return &tape.buf[pos];
}

/**********************************************************************
	e[v[^[̃CxgnhƁA[^[̐
**********************************************************************/

/* set motor event */
static void cmt_motor_start(void (*callback)(int),int param)
{
	/* e[vpCxg^C}[̍\zƓo^ */
	/* CPŨNbN͎xvZBݒlQƂĂ̓_B */
	motor_event.name     = "CMT MOTOR";
	motor_event.interval =  TIME_IN_CYCLES(4000000L,0) / tape_freq;
	motor_event.callback = callback;
	motor_event.callback_param = param;
	event_set(&motor_event,motor_event.interval);
}

/* ݃rbgωɃe[v̌݃rbgʒu̒Ԃ֒ */
static void adjust_rec_timming(void)
{
	if( tape.cur_cmd == CMD_REC)
	{
		event_set(&motor_event,motor_event.interval/2);
	}
}

/* ĐA^C}[ */
static void cmt_play_callback(int param)
{
	if( ++tape_pos >= tape_end)
	{
		tape_pos = tape_end-1;
		tape.break_flag=1;
		cmt_stop();
	}
}

/* ^A^C}[ */
static void cmt_rec_callback(int param)
{
	BYTE bit_mask;
	BYTE *ptr;

	/* ݃|CgƃrbgʒǔvZ */
	bit_mask  = 0x80 >> (tape_pos&7);
	ptr = cmt_data_ptr(tape_pos/8);

	/* ꎞobt@ւ̃f[^ */
	if(tape.data)
		(*cmt_data_ptr(tape_pos/8)) |= bit_mask;
	else
		(*cmt_data_ptr(tape_pos/8)) &= ~bit_mask;
	tape.dirty_buf = 1;

	/* Ƃ́AĐƓ */
	cmt_play_callback(0);
}

/* 莞A^C}[ */
static void cmt_ff_callback(int param)
{
	tape_pos+=FF_REW_RATE;
	if( tape_pos >= tape_end)
	{
		tape_pos = tape_end-1;
		cmt_stop();
	}
}

/* ߂A^C}[ */
static void cmt_rew_callback(int param)
{
	if( tape_pos <= FF_REW_RATE)
	{
		tape_pos = 0;
		cmt_stop();
		return;
	}
	tape_pos-=FF_REW_RATE;
}

/* APSS ^߂@^C}[ */
static void cmt_apss_callback(int direction)
{
	int i;
	BYTE data,mask;
	int num_bit =0;

	/* tape end check */
	if(direction > 0)
	{
		/*  */
		if( tape_pos+FF_REW_RATE >= tape_end)
		{
			tape_pos = tape_end-1;
			cmt_stop();
			return;
		}
	}
	else
	{
		/* ߂ */
		if( tape_pos <= FF_REW_RATE)
		{
			tape_pos = 0;
			cmt_stop();
			return;
		}
	}

	/* e[vʒu̍XVƁAopf[^Tv */
	for( i=0 ; i < FF_REW_RATE ; i++)
	{
		mask  = 0x80>>(tape_pos&7);
		data  = *cmt_data_ptr(tape_pos/8);
		if(data&mask)
			num_bit++;
		tape_pos += direction;
	}

	/* OA1̊I */
	if(num_bit*2 > FF_REW_RATE) // 50% ?
		num_bit = FF_REW_RATE-num_bit;

	/* oAM̈x80%ȏ̎Ɣ */
	if( num_bit*5 < FF_REW_RATE) // 20%
	{	/* FLoȂJE^Zbg */
		if( (tape.apss_cnt >= -tape.apss_over) && (tape.apss_cnt <0) )
			tape.apss_cnt = -tape.apss_over;
	}
	else
	{	/* LFoȂJE^Zbg */
		if(tape.apss_cnt >0)
			tape.apss_cnt = 0;
	}

	/* oJE^̍XVƁAo`FbN */
	if( (tape.apss_cnt += FF_REW_RATE) >= tape.apss_over)
	{	/* found one of APSS */
		cur_cmd = CMD_STOP: /* BREAKM */
		cmt_stop();
	}
}

/* wbh_EI */
static void cmt_head_down_callback(int param)
{
	int direction;
	int ff_flag = 0;

	tape.busy = 0;
	tape.headdown = 1;

	switch(tape.cur_cmd)
	{
		case CMD_PLAY:
			cmt_motor_start(cmt_play_callback,0);
			/* no wait ! */
			xmilcfg.NOWAIT |= 0x02;
			break;
		case CMD_FF:
			ff_flag = 1;
			cmt_motor_start(cmt_ff_callback,0);
			break;
		case CMD_REW:
			ff_flag = 1;
			cmt_motor_start(cmt_rew_callback,0);
			break;
		case CMD_AFF:
		case CMD_AREW:
			ff_flag = 1;
			direction = (tape.cur_cmd==CMD_AFF) ? 1 : -1;
			tape.apss_num = direction;
			tape.apss_cnt = -tape.apss_over;
			cmt_motor_start(cmt_apss_callback,direction);
			tape.busy = 1;
			/* no wait ! */
			xmilcfg.NOWAIT |= 0x02;
			break;
		case CMD_REC:
			if(tape_protect) return;
			cmt_motor_start(cmt_rec_callback,0);
			/* no wait ! */
			xmilcfg.NOWAIT |= 0x02;
			break;
		default:
			cmt_head_up();
	}
	if(ff_flag && xmilcfg.MOTOR)
		WAVE_PLAY(WAV_FFREW,1);
}

/* wbh_EJn */
static void cmt_head_down(void)
{
	if(!tape_freq)
		return;

	if(!tape.headdown)
	{
		/* wbhAbvԂȂ̂ŁA0.5bɃwbh_E */
		motor_event.name     = "CMT HEAD DOWN";
		motor_event.interval = 0;
		motor_event.callback = cmt_head_down_callback;
		event_set(&motor_event,TIME_IN_MSEC(500));
		tape.busy = 1;

		if(xmilcfg.MOTOR)
			WAVE_PLAY(WAV_PLAY,0);
	}
	else
		cmt_head_down_callback(0);
}

/* wbhAbvI */
static void cmt_head_up_callback(int param)
{
	tape.busy = 0;
	tape.headdown = 0;
	tape.break_flag=0;

	switch(tape.cur_cmd)
	{
		case CMD_EJECT:
			/* 920ms(-110ms)ɃCWFNg */
			motor_event.name     = "CMT EJECT";
			motor_event.interval = 0;
			motor_event.callback = cmt_eject_callback;
			event_set(&motor_event,TIME_IN_MSEC(920-110));
			tape.busy = 1;

			if(xmilcfg.MOTOR)
				WAVE_PLAY(WAV_EJECT,0);
			break;
		case CMD_STOP:
			/* 200ms(-110ms)ɃXe[^Xԑ */
			motor_event.name     = "CMT EJECT";
			motor_event.interval = 0;
			motor_event.callback = cmt_stop_callback;
			event_set(&motor_event,TIME_IN_MSEC(200-110));
			tape.busy = 1;
			break;
		case CMD_PLAY:
		case CMD_REC:
			/* 520msɃXe[^Xԑ */
			if(tape_freq)
				cmt_head_down();
			break;
		case CMD_FF:
		case CMD_REW:
		case CMD_AFF:
		case CMD_AREW:
			/* 100msAX1{̂ɏԒʒm */
			break;
	}
}

/* wbhAbvJn */
static void cmt_head_up(void)
{
	if(tape.headdown)
	{
		/* 110ms */
		motor_event.name     = "CMT HEAD UP";
		motor_event.interval = 0;
		motor_event.callback = cmt_head_up_callback;
		event_set(&motor_event,TIME_IN_MSEC(110));
		tape.busy = 1;
		/* wbh */
		if(xmilcfg.MOTOR)
		{
			WAVE_STOP(WAV_FFREW);
			WAVE_PLAY(WAV_STOP,0);
		}
		xmilcfg.NOWAIT &= 0xfd;
	}
	else
	{
		/* łɂĂȀ */
		cmt_head_up_callback(0);
	}
}

/**********************************************************************
	e[v̓^CWFNg {^ ɑ֐
**********************************************************************/

char *cmt_get_tape_name(void)
{
	return tape_filename;
}

// sw ... 0=^ 1=^s
void cmt_set(char *fname)
{
	FILEH hdr;

	cmt_ctrl(CMD_EJECT);

	strcpy(tape_filename,fname);
	if ((hdr = file_open(tape_filename)) == (FILEH)-1)
		return;
	/* file length */
	tape.filesize = file_length(hdr);
	if(tape.filesize < sizeof(tape.header) )
		return;

	/* read header */
	file_read(hdr, &tape.header ,sizeof(tape.header));
	file_close(hdr);

	/* when old format file , auto conversion */
	if(tape.header.index != TAPE_INDEX)
	{
		DWORD frq = tape.header.index;
		memcpy(&tape.header,&default_header,sizeof(X1TAPE_HEADER) );
		tape_freq = frq;
		tape_end  = (tape.filesize - sizeof(X1TAPE_HEADER))*8;
#if 1
		/* ϊĂ悢ǂ̊mF */
extern HWND hWndMain;

		if( MessageBox(hWndMain,"\
tH[}bg̃e[vt@CłB\n\
ϊƐ擪RUoCg̃f[^͎܂B\n\
VtH[}bgɎϊ܂H"
			,"mF",MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL ) != IDYES )
		{
			tape.header.index = 0; /* Z[uȂ悤 */
		}
#endif
		/* save the header */
		cmt_save_header();
	}

	/* set tape */
	tape.cur_cmd = CMD_STOP;
	/* set protect bit */
	cmt_set_protect(tape_protect);

	tape.apss_over = (long)(1* tape_freq); // APSS 0.5sec
	tape.page=-1;

	/* update display status */
	makecaption(1);
}

void cmt_set_protect(BYTE sw)
{
#if 1
#include	"resource.h"
#define	MFCHECK(a) ((a)?MF_CHECKED:MF_UNCHECKED)
extern HWND hWndMain;
	CheckMenuItem(GetMenu(hWndMain), IDM_CMTPROTECT, MFCHECK(sw));
#endif
	tape_protect = sw ? TAPE_PROTECT : 0;
}

/**********************************************************************
	e[v̂Prbgo
**********************************************************************/

/* read tape port :bit0=break , bit1 = read data */
BYTE cmt_read(void)
{
	BYTE data,bitmask;
	BYTE ret;

	/* bit0 == 1A03.bit0 == BREAK rbg,TubotƂlow or */
	ret = tape.break_flag ? 0x00 : 0x01;
	/* bit1 e[vf[^̃Zbg */
	if(tape.cur_cmd == CMD_PLAY)
	{
		/* e[vf[^ */
		bitmask = 0x80>>(tape_pos&7);
		data =*cmt_data_ptr(tape_pos/8);
		if( data & bitmask)
			ret |= 0x02;
	}
	return ret;
}

void cmt_write(BYTE data)
{
	if(tape.data != data)
	{
		adjust_rec_timming();
		tape.data = data;
	}
}

/**********************************************************************
	TubotfbLRg[ׂ̈ɃR[֐
**********************************************************************/

void cmt_ctrl(BYTE cmnd)
{
	/* if same command , redirect status */
	if(tape.cur_cmd == cmnd)
	{
		x1_sub_cmtrx(tape.cur_cmd);
		return;
	}
	/* update write data only RECoading */
	cmt_flush_buffer();
	/* update command */
	tape.cur_cmd = cmnd;
	/* if EJECT , remove tape file */
	if(cmnd == CMD_EJECT)
	{
		cmt_save_header();
		/* clear tape data */
		tape_filename[0] = 0;
		/* */
		tape.header.index = 0;
		tape_freq      = 0;
		tape_pos       = 0;
		tape_end       = 0;
		cmt_set_protect(0);
	}
	/* wbh~ĂAxwbhグĂs */
	cmt_head_up();
	/* update display status */
	makecaption(1);
}

BYTE cmt_busy(void)
{
	return tape.busy;
}

BYTE cmt_tape_stat(void)
{
	BYTE ans = 0;

	if(!tape_protect ) ans|=4; //  1=OK 0=ݼ
	if(tape.cur_cmd != CMD_EJECT) ans|=2; //  0=ż 1=
	if(tape_pos >= tape_end-1) ans|=1; // 0=ðߴ
	return ans;
}

BYTE cmt_ctrl_stat(void)
{
	return tape.cur_cmd;
}

#else //T_TUNE

#include	<windows.h>
#include	"x1.h"

static	BYTE	CMT_CMND = 0;
static	BYTE	CMT_STOP = 1;

void init_cmt(void) {

	CMT_CMND = 0;
	CMT_STOP = 1;
}

BYTE cmt_read(void) { return(0); }

void cmt_write(BYTE dat) { }

void cmt_ctrl(BYTE cmnd)
{
	switch(cmnd){
		case 0x00:				// EJECT

		case 0xff:				// APSS and next empty!
		case 0x01:				// STOP
			CMT_STOP = 1;
			break;
//		case 0x02:				// PLAY
//		case 0x03:				// FF
//		case 0x04:				// REW
//		case 0x05:				// APSS_FF
//		case 0x06:				// APSS_REW
//		case 0x0a:				// REC
//			break;
	}
	CMT_CMND = cmnd;
}

BYTE cmt_tape_stat(void) { return(0); }

BYTE cmt_ctrl_stat(void) { return(CMT_CMND); }

BYTE cmt_test(void) {

	if (CMT_STOP) {
		CMT_STOP = 0;
		return(0);
	}
	return(1);
}
#endif //T_TUNE
